/* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * By using this code and algorithm, you agree that you are completely
 * responisble for your own actions. LAN tools project, and I, Nickolsky Artyom, are in no way
 * liable for any actions taken using this code and algorithm.
 *
 *  Copyright 2001 LAN tools project. 
 *  Copyright 2001 Nickolsky Artyom.
 * E-mail: nickolsky@yandex.ru
 * URL: http://lantools.narod.ru
 */
// PassResDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PassRes.h"
#include "PassResDlg.h"
#include "respass.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPassResDlg dialog

CPassResDlg::CPassResDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPassResDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPassResDlg)
	m_sIP = _T("");
	m_sNBName = _T("");
	m_sShare = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPassResDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPassResDlg)
	DDX_Text(pDX, IDC_IP, m_sIP);
	DDX_Text(pDX, IDC_NBNAME, m_sNBName);
	DDX_Text(pDX, IDC_SHARE, m_sShare);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPassResDlg, CDialog)
	//{{AFX_MSG_MAP(CPassResDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPassResDlg message handlers

BOOL CPassResDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPassResDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CPassResDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPassResDlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData( TRUE );
	if( OpenSMBConnection( m_sNBName, m_sIP ) )
	{
		CString sPassword;
		BOOL isResolved;
		sPassword = ResolveSMBPassword( m_sShare, &isResolved );
		CloseSMBConnection( );
		OpenClipboard( );
		HGLOBAL hResult = GlobalAlloc( GMEM_DDESHARE, strlen( sPassword ) + 1 );
		char * sResult;
		sResult = ( char * )GlobalLock( hResult );
		strcpy( sResult, sPassword );
		GlobalUnlock( hResult );
		EmptyClipboard( );
		HANDLE res = SetClipboardData( CF_TEXT, hResult );
		CloseClipboard( );
		if( isResolved )
			MessageBox( "Password \"" + sPassword +"\" was saved to clipboard" );
		else
			MessageBox( "Password not found. Resolution result \"" + sPassword +"\" was saved to clipboard" );
	}
	//CDialog::OnOK();
}
