/* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * By using this code and algorithm, you agree that you are completely
 * responisble for your own actions. LAN tools project, and I, Nickolsky Artyom, are in no way
 * liable for any actions taken using this code and algorithm.
 *
 *  Copyright 2001 LAN tools project. 
 *  Copyright 2001 Nickolsky Artyom.
 * E-mail: nickolsky@yandex.ru
 * URL: http://lantools.narod.ru
 */
#ifndef ___PROTOCOL_SMB_PASSWORD_RESOLVER_H_
#define ___PROTOCOL_SMB_PASSWORD_RESOLVER_H_

#include"stdafx.h"
#include<afxsock.h>
#include"protocol.h"

BOOL OpenSMBConnection( CString sName, CString sAddress);

void CloseSMBConnection( );

CString ResolveSMBPassword( CString sResource, BOOL * isResolved );

void SendSMBConnectionRequest( CString sResource, CString sPassword, BOOL isNullTerminated );

BOOL GetSMBConnectionResponce( );

void SendSMBSessionRequest( );

BOOL GetSMBSessionResponce( );

void SendSMBNegotiateRequest( );

BOOL GetSMBNegotiationResponce( );

void SetCharSet( CString sChars );


#endif
